package qreaderwrapper;

import anywheresoftware.b4a.AbsObjectWrapper;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;

import main.java.github.nisrulz.qreader.QREader;
import main.java.github.nisrulz.qreader.QRDataListener;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.SurfaceView;
import android.widget.TextView;
import android.app.Activity;

import main.java.github.nisrulz.qreader.R;

import android.view.View;
import android.content.Context;
import android.view.ViewGroup;

import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.CameraInfo;

import android.widget.LinearLayout;

import android.app.ActivityManager;
import android.content.Intent;

import android.content.pm.PackageManager;
import android.widget.Toast;

import java.util.List;

@ActivityObject
@ShortName("QREader")
@Events(values={"scan_result(result As String)"})
@Author("Github: Nishant Srivastava, Wrapped by: Johan Schoeman")
@Version(1.00f)
@DependsOn(values={"android-support-v4", "android-support-v7-appcompat", "google-play-services"})


public class qreaderWrapper extends AbsObjectWrapper<QREader> {
	private BA ba;
	private String eventName;
	SurfaceView surfaceView;
	TextView textView_qrcode_info;	
	private Camera myCamera;
	private int cntr = 0;
	
   /**
	* The ID of the front facing camera
	* If the ID is -1 after initialization then the device does not support a front facing camera
	* If the device has front and back cameras then the ID's will be BACK = 0 and FRONT = 1 after initialization
	* If the device has a back camera only then the ID's will be BACK = 0 and FRONT = -1 after initialization
	* If the device has a front camera only then the ID's will be BACK = -1 and FRONT = 0 after initialization
	*/

	public int CAMERA_FRONT = -1;
   /**
	* The ID of the back facing camera
	* If the ID is -1 after initialization then the device does not support a back facing camera
	* If the device has front and back cameras then the ID's will be BACK = 0 and FRONT = 1 after initialization
	* If the device has a back camera only then the ID's will be BACK = 0 and FRONT = -1 after initialization
	* If the device has a front camera only then the ID's will be BACK = -1 and FRONT = 0 after initialization
	*/
	public int CAMERA_BACK = -1;		

	public void Initialize(BA paramBA, String paramString)
	{
	eventName = paramString.toLowerCase(BA.cul);
	ba = paramBA;

	QREader cv = new QREader();
	String str = paramString.toLowerCase(BA.cul);
	
	setObject(cv);
	prepViews();
	
	}
  
    private void prepViews() {
			
		ba.activity.setContentView(BA.applicationContext.getResources().getIdentifier("activity_main", "layout", BA.packageName));

		String resourceName="camera_view";
		int resourceId = BA.applicationContext.getResources().getIdentifier(resourceName, "id", BA.packageName);
		surfaceView = (SurfaceView) ba.activity.findViewById(resourceId);
		
	    String resname = "code_info";
		int resId = BA.applicationContext.getResources().getIdentifier(resname, "id", BA.packageName);
        textView_qrcode_info = (TextView) ba.activity.findViewById(resId);	
	
	}	
	
	/**
     * Start the barcode scanner
     */			
	public void StartScan() {
		ScannerActive = true;
        ((QREader)getObject()).start(BA.applicationContext, surfaceView, new QRDataListener() {
            @Override
            public void onDetected(final String data) {
                if (ba.subExists(eventName + "_scan_result")) {
				  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_scan_result", true, new Object[] {data});				
			    }
                textView_qrcode_info.post(new Runnable() {
                    @Override
                    public void run() {
                        textView_qrcode_info.setText(data);
                    }
                });
            }
        });		
		
	}

	/**
     * Stop the barcode scanner
     */		
	public void StopScan() {
		ScannerActive = false;
        ((QREader)getObject()).stop(BA.applicationContext, surfaceView);

        Intent intent = ba.activity.getIntent();
        ba.activity.finish();
        ba.activity.startActivity(intent);

	}
	
	/**
     * Set the initial scanner text to be displayed (i.e before a barcode is scannned)
     */			
	public void setInitialScannerText(String scannertext) {
		textView_qrcode_info.setText(scannertext);
	}
	
	
    private int ctu = 0;
    /**
     * Set the camera to be use	for recording
     * For a device with front and back cameras ---> front = 1 and back = 0
     * for a device with a front camera only ---> front = 0
     * for a device with a back facing camera only ---> back = 0
     * Use avc1.BackFacingCamera and avc1.FrontFacingCamera to get the camera ID's
     */
    public void setCameraToUse (int ctu) {
      ((QREader)getObject()).setCameraToUse(ctu);
    }	

	/**
     * Set the scanner text color
     */	
    public void setScannerTextColor(int ScannerTextColor) {
		textView_qrcode_info.setTextColor(ScannerTextColor);
	}
	
	/**
     * Set the scanner text size
     */		
    public void setScannerTextSize(int ScannerTextSize) {
		textView_qrcode_info.setTextSize(ScannerTextSize);
	}	
   
   
    /**
     * Get the ID of the front facing camera
     * If the device has a front and back camera then the ID = 1
     * If the device has a front facing camera only then the ID = 0
     * It will return the ID as -1 if there is no front facing camera
     */
	public int getFrontFacingCamera() {
		int cameraId = -1;
		// Search for the front facing camera
		// get the number of cameras		
		int numberOfCameras = Camera.getNumberOfCameras();
		// for every camera check		
		for (int i = 0; i < numberOfCameras; i++) {
			CameraInfo info = new CameraInfo();
			Camera.getCameraInfo(i, info);
			if (info.facing == CameraInfo.CAMERA_FACING_FRONT) {
				cameraId = i;
				break;
			}
		}
        CAMERA_FRONT = cameraId;
		return cameraId;
	}


    /**
     * Get the ID of the back facing camera
     * If the device has a front and back camera then the ID = 0
     * If the device has a back facing camera only then the ID = 0
     * It will return the ID as -1 if there is no back facing camera
     */
	public int getBackFacingCamera() {
		int cameraId = -1;
		// Search for the back facing camera
		// get the number of cameras
		int numberOfCameras = Camera.getNumberOfCameras();
		// for every camera check
		for (int i = 0; i < numberOfCameras; i++) {
			CameraInfo info = new CameraInfo();
			Camera.getCameraInfo(i, info);
			if (info.facing == CameraInfo.CAMERA_FACING_BACK) {
				cameraId = i;
				break;
			}
		}
        CAMERA_BACK = cameraId;
		return cameraId;
	}	
	
	private boolean ScannerActive = false;
	public boolean isScannerActive() {
		return ScannerActive;
	}
	
	

}
